"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function() {
        return _default;
    }
});
var _xpath = /*#__PURE__*/ _interopRequireDefault(require("xpath"));
var _xmldom = require("xmldom");
var _vconsole = /*#__PURE__*/ _interopRequireDefault(require("vconsole"));
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function funDownload(number, filename) {
    var eleLink = document.createElement("a");
    eleLink.download = filename;
    eleLink.style.display = "none";
    var result = [];
    for(var i = 0; i < number; i++){
        var content = localStorage.getItem("log_".concat(i));
        result.push(new Blob([
            "".concat(content, "\n\n")
        ]));
        localStorage.removeItem("log_".concat(i));
    }
    var blob = new Blob(_toConsumableArray(result));
    eleLink.href = URL.createObjectURL(blob);
    document.body.appendChild(eleLink);
    eleLink.click();
    document.body.removeChild(eleLink);
}
var logInstance = new _vconsole.default.VConsolePlugin("exportNetworkLog", "exportNetworkLog");
logInstance.on("ready", function() {
    console.log("[vconsole-network-log] -- load");
});
logInstance.on("renderTab", function(callback) {
    var html = '<div class="vconsole-exportlog">\n  </div>';
    callback(html);
});
logInstance.on("addTool", function(callback) {
    var buttons = [
        {
            name: "exportNetworkLogs",
            onClick: function() {
                var netEle = document.getElementById("__vc_tab_network");
                var exportEle = document.getElementById("__vc_tab_exportnetworklog");
                netEle.click();
                setTimeout(function() {
                    exportEle.click();
                    var nodes = document.querySelectorAll(".vc-group-detail");
                    for(var i = 0; i < nodes.length; i++){
                        var node = nodes[i];
                        var _str = "";
                        var xml = node.innerHTML;
                        var doc = new _xmldom.DOMParser().parseFromString(xml);
                        var result = _xpath.default.evaluate("/div/div/*", doc, null, _xpath.default.XPathResult.ANY_TYPE, null // result
                        );
                        node = result.iterateNext();
                        var index = 0;
                        try {
                            while(node){
                                var data = (node.firstChild || {}).data;
                                if (data) {
                                    if (index % 2 === 0) {
                                        _str += "".concat(node.firstChild.data, ",");
                                    } else {
                                        _str += "".concat(node.firstChild.data, "\n");
                                    }
                                }
                                index++;
                                node = result.iterateNext();
                            }
                        } catch (error) {
                            console.error(error);
                        }
                        localStorage.setItem("log_".concat(i), _str);
                    }
                    funDownload(nodes.length, "".concat(new Date().toLocaleDateString() + " " + new Date().toLocaleTimeString(), ".log"));
                }, 300);
            }
        }
    ];
    callback(buttons);
});
var _default = logInstance;
