import xpath from 'xpath'
import { DOMParser } from 'xmldom'
import VConsole from 'vconsole';


function funDownload(number, filename) {
  var eleLink = document.createElement("a");
  eleLink.download = filename;
  eleLink.style.display = "none";
  const result = []
  for (let i = 0; i < number; i++) {
    const content = localStorage.getItem(`log_${i}`)
    result.push(new Blob([`${content}\n\n`]))
    localStorage.removeItem(`log_${i}`)
  }
  var blob = new Blob([...result]);
  eleLink.href = URL.createObjectURL(blob);
  document.body.appendChild(eleLink);
  eleLink.click();
  document.body.removeChild(eleLink);
}

const logInstance = new VConsole.VConsolePlugin(
  "exportNetworkLog",
  "exportNetworkLog"
);

logInstance.on("ready", () => {
  console.log('[vconsole-network-log] -- load');
});

logInstance.on("renderTab", (callback) => {
  const html = `<div class="vconsole-exportlog">
  </div>`;
  callback(html);
});

logInstance.on("addTool", (callback) => {
  const buttons = [
    {
      name: "exportNetworkLogs",
      onClick: () => {
        const netEle = document.getElementById('__vc_tab_network')
        const exportEle = document.getElementById('__vc_tab_exportnetworklog')
        netEle.click()
        setTimeout(() => {
          exportEle.click()
          let nodes = document.querySelectorAll(".vc-group-detail")
          for (let i = 0; i < nodes.length; i++) {
            let node = nodes[i]
            let _str = ''
            let xml = node.innerHTML
            var doc = new DOMParser().parseFromString(xml)
            var result = xpath.evaluate(
              "/div/div/*",            // xpathExpression
              doc,                        // contextNode
              null,                       // namespaceResolver
              xpath.XPathResult.ANY_TYPE, // resultType
              null                        // result
            )
            node = result.iterateNext();
            let index = 0
            try {
              while (node) {
                const { data } = node.firstChild || {}
                if (data) {
                  if (index % 2 === 0) {
                    _str += `${node.firstChild.data},`
                  } else {
                    _str += `${node.firstChild.data}\n`
                  }
                }
                index++
                node = result.iterateNext();
              }
            } catch (error) {
              console.error(error)
            }
            localStorage.setItem(`log_${i}`, _str)
          }
          funDownload(nodes.length, `${new Date().toLocaleDateString() + ' ' + new Date().toLocaleTimeString()}.log`)
        }, 300);
      },
    },
  ];
  callback(buttons);
});

export default logInstance